<template>
  <main class="container grid">
    <comment-item
      v-for="comment in storedComments"
      :key="comment.id"
      :id="comment.id"
      :content="comment.content"
      :created-at="comment.createdAt"
      :score="comment.score"
      :user="comment.user"
    >
      <comment-replies
        v-if="comment.replies.length > 0"
        :id="comment.id"
        :replies="comment.replies"
      ></comment-replies>
    </comment-item>
    <new-comment :currentUser="currentUser"></new-comment>
  </main>
</template>

<script>
import CommentItem from "./CommentItem.vue";
import CommentReplies from "./CommentReplies.vue";
import NewComment from "./NewComment.vue";

export default {
  name: "App",
  components: {
    CommentItem,
    CommentReplies,
    NewComment,
  },
  data() {
    return {
      currentUser: {
        image: {
          png: "image-juliusomo.png",
          webp: "image-juliusomo.webp",
        },
        username: "juliusomo",
      },
      storedComments: [
        {
          id: 1,
          content:
            "Impressive! Though it seems the drag feature could be improved. But overall it looks incredible. You've nailed the design and the responsiveness at various breakpoints works really well.",
          createdAt: "10/20/2015",
          score: 12,
          user: {
            image: {
              png: "image-amyrobson.png",
              webp: "image-amyrobson.webp",
            },
            username: "amyrobson",
          },
          replies: [],
        },
        {
          id: 2,
          content:
            "Woah, your project looks awesome! How long have you been coding for? I'm still new, but think I want to dive into React as well soon. Perhaps you can give me an insight on where I can learn React? Thanks!",
          createdAt: "10/20/2015",
          score: 5,
          user: {
            image: {
              png: "image-maxblagun.png",
              webp: "image-maxblagun.webp",
            },
            username: "maxblagun",
          },
          replies: [
            {
              id: 3,
              content:
                "If you're still new, I'd recommend focusing on the fundamentals of HTML, CSS, and JS before considering React. It's very tempting to jump ahead but lay a solid foundation first.",
              createdAt: "10/20/2015",
              score: 4,
              replyingTo: "maxblagun",
              user: {
                image: {
                  png: "image-ramsesmiron.png",
                  webp: "image-ramsesmiron.webp",
                },
                username: "ramsesmiron",
              },
            },
            {
              id: 4,
              content:
                "I couldn't agree more with this. Everything moves so fast and it always seems like everyone knows the newest library/framework. But the fundamentals are what stay constant.",
              createdAt: "10/20/2015",
              score: 2,
              replyingTo: "ramsesmiron",
              user: {
                image: {
                  png: "image-juliusomo.png",
                  webp: "image-juliusomo.webp",
                },
                username: "juliusomo",
              },
            },
          ],
        },
      ],
    };
  },
  computed: {},
  provide() {
    return {
      currentUser: this.currentUser,
      comments: this.storedComments,
      addComment: this.addComment,
      addReply: this.addReply,
      editComment: this.editComment,
      deleteComment: this.deleteComment,
      increaseScore: this.increaseScore,
      decreaseScore: this.decreaseScore,
    };
  },
  methods: {
    addComment(content) {
      const newComment = {
        id: new Date().toISOString(),
        createdAt: new Date().toLocaleString(),
        content: content,
        user: this.currentUser,
        score: 0,
        replies: [],
      };
      this.storedComments.push(newComment);
    },
    addReply(commentId, replyId, content) {
      const comment = this.storedComments.find((res) => res.id === commentId);
      var reply;
      if (replyId) {
        reply = comment.replies.find((res) => res.id === replyId);
      }
      const replyingTo = reply ? reply.user.username : comment.user.username;
      const newReply = {
        id: new Date().toISOString(),
        createdAt: new Date().toLocaleString(),
        content: content,
        replyingTo: replyingTo,
        user: this.currentUser,
        score: 0,
        replies: [],
      };
      comment.replies.push(newReply);
    },
    editComment(commentId, replyId, newContent) {
      const comment = this.storedComments.find((res) => res.id === commentId);
      if (replyId) {
        const reply = comment.replies.find((res) => res.id === replyId);
        reply.content = newContent;
      } else {
        comment.content = newContent;
      }
    },
    deleteComment(commentId, replyId) {
      if (replyId) {
        const comment = this.storedComments.find((res) => res.id === commentId);
        const replyIndex = comment.replies.findIndex(
          (res) => res.id === replyId
        );
        comment.replies.splice(replyIndex, 1);
      } else {
        const commentIndex = this.storedComments.findIndex(
          (res) => res.id === commentId
        );
        this.storedComments.splice(commentIndex, 1);
      }
    },
    increaseScore(commentId, replyId) {
      const comment = this.storedComments.find((res) => res.id === commentId);
      if (replyId) {
        const reply = comment.replies.find((res) => res.id === replyId);
        reply.score += 1;
      } else {
        comment.score += 1;
      }
    },
    decreaseScore(commentId, replyId) {
      const comment = this.storedComments.find((res) => res.id === commentId);
      if (replyId) {
        const reply = comment.replies.find((res) => res.id === replyId);
        reply.score -= 1;
      } else {
        comment.score -= 1;
      }
    },
  },
};
</script>

<style>
@import url("https://fonts.googleapis.com/css2?family=Rubik:wght@400;500;700&display=swap");

/* ------------------- */
/* Custom properties   */
/* ------------------- */

:root {
  /* colors */
  --clr-primary-400: hsl(357, 100%, 86%);
  --clr-primary-500: hsl(239, 57%, 85%);
  --clr-primary-600: hsl(358, 79%, 66%);
  --clr-primary-700: hsl(238, 40%, 52%);

  --clr-neutral-100: hsl(0, 0%, 100%);
  --clr-neutral-200: hsl(228, 33%, 97%);
  --clr-neutral-300: hsl(223, 19%, 93%);
  --clr-neutral-400: hsl(211, 10%, 45%);
  --clr-neutral-500: hsl(212, 24%, 26%);

  /* font-sizes */
  --fs-body: 1rem;

  /* font-families */
  --ff-primary: "Rubik", sans-serif;

  /* font-weights */
  --fw-400: 400;
  --fw-500: 500;
  --fw-700: 700;
}

/* ------------------- */
/* Reset               */
/* ------------------- */

/* https://piccalil.li/blog/a-modern-css-reset/ */

/* Box sizing rules */
*,
*::before,
*::after {
  box-sizing: border-box;
}

/* Remove default margin */
body,
h1,
h2,
h3,
h4,
p,
figure,
blockquote,
dl,
dd {
  margin: 0;
}
h1,
h2,
h3,
h4,
h5,
h6,
p {
  font-weight: var(--fw-400);
  font-size: var(--fs-body);
}
/* Remove list styles on ul, ol elements with a list role, which suggests default styling will be removed */
ul[role="list"],
ol[role="list"] {
  list-style: none;
}

/* Set core root defaults */
html:focus-within {
  scroll-behavior: smooth;
}

/* Set core body defaults */
body {
  min-height: 100vh;
  text-rendering: optimizeSpeed;
  line-height: 1.5;
}

/* A elements that don't have a class get default styles */
a:not([class]) {
  text-decoration-skip-ink: auto;
}

/* Make images easier to work with */
img,
picture {
  max-width: 100%;
  display: block;
}

/* Inherit fonts for inputs and buttons */
input,
button,
textarea,
select {
  font: inherit;
}

/* Remove all animations, transitions and smooth scroll for people that prefer not to see them */
@media (prefers-reduced-motion: reduce) {
  html:focus-within {
    scroll-behavior: auto;
  }

  *,
  *::before,
  *::after {
    animation-duration: 0.01ms !important;
    animation-iteration-count: 1 !important;
    transition-duration: 0.01ms !important;
    scroll-behavior: auto !important;
  }
}

/* ------------------- */
/* Utility classes     */
/* ------------------- */

/* general */

.flex {
  display: flex;
  gap: var(--gap, 1rem);
  align-items: center;
}

.grid {
  display: grid;
  gap: var(--gap, 1rem);
}

.d-block {
  display: block;
}

.flow > *:where(:not(:first-child)) {
  margin-top: var(--flow-space, 1rem);
}

.flow--space-small {
  --flow-space: 0.75rem;
}

.container {
  /* padding-inline: 2em; */
  margin-inline: auto;
  margin-block: 2rem;
  max-width: 50rem;
}
/* colors */

.bg-neutral-100 {
  background-color: var(--clr-neutral-100);
}
.bg-neutral-200 {
  background-color: var(--clr-neutral-200);
}
.bg-primary-700 {
  background-color: var(--clr-primary-700);
}

.text-primary-700 {
  color: var(--clr-primary-700);
}

.text-primary-600 {
  color: var(--clr-primary-600);
}
.text-neutral-500 {
  color: var(--clr-neutral-500);
}
.text-neutral-400 {
  color: var(--clr-neutral-400);
}
/* typography */

.fw-400 {
  font-weight: var(--fw-400);
}
.fw-500 {
  font-weight: var(--fw-500);
}
.fw-700 {
  font-weight: var(--fw-700);
}
/* set up the body */
body {
  font-family: var(--ff-primary);
  font-size: var(--fs-body);
  color: var(--clr-neutral-400);
  background-color: var(--clr-neutral-200);
  /* display: grid; */
  /* grid-template-rows: min-content 1fr; */
  overflow-x: hidden;
}
textarea {
  cursor: pointer;
  padding: 0.5rem 1.5rem;
  border: 1px solid var(--clr-neutral-300);
  border-radius: 0.5rem;
  height: 7rem;
  width: 100%;
  background-color: var(--clr-neutral-100);
  color: var(--clr-neutral-400);
  resize: none;
}
</style>
